dnl PERL macros for autoconf

dnl
dnl Checks for perl programs, set absolute path to $PERL
dnl
AC_DEFUN(AC_PROG_PERL,
[AC_PATH_PROGS(PERL, perl perl5, false)
if test "x$PERL" = "xfalse"; then
  AC_MSG_ERROR([Perl program not found])
fi
])

dnl
dnl Checks for perl module
dnl
dnl AC_CHECK_PERL_MODULE(VARIABLE, MODULE [, VERSION])
AC_DEFUN(AC_CHECK_PERL_MODULE,
[AC_REQUIRE([AC_PROG_PERL])dnl
ac_msg_module="$2"
if test "x$3" != "x"; then
  ac_msg_module="$2 v$3"
fi
AC_MSG_CHECKING([$ac_msg_module perl module])
ac_have_module="no"
if test "x`$PERL -e 'use $2 $3;' 2>&1`" = "x"; then
  ac_have_module="yes"
fi
$1="$ac_have_module"
AC_MSG_RESULT([$]$1)
])

dnl A macro to check the options of nice, in order to have a
dnl VERY_NICE variable which runs a program at the lowest priority
dnl VERY_NICE is undefined if we don't find the proper options, so
dnl you can safely use:
dnl   @VERY_NICE@ mycommand
dnl in a shell script.
dnl The VERY_NICE variable includes the placeholder NICE_VALUE that
dnl you have to instantiate at run-time.
dnl If you give a argument to AC_VERY_NICE, it will be used for testing
dnl and included in VERY_NICE instead of the above placeholder.
AC_DEFUN(AC_VERY_NICE,[ 
if test "x$1" != "x"; then
  NICE_VALUE=$1
else
  NICE_VALUE=5
fi
AC_CHECK_PROGS(TEST_NICE, date)
dnl AC_CHECK_PROGS(NICE, nice, )
AC_PATH_PROGS(NICE, nice, )
AC_MSG_CHECKING(syntax of nice)
if test "x$NICE" != "x"; then
     if  ( $NICE -n $NICE_VALUE $TEST_NICE > /dev/null 2>&1 ) ;  then 
	VERY_NICE="$NICE -n $NICE_VALUE"
     else 
      if  ( $NICE -$NICE_VALUE $TEST_NICE > /dev/null 2>&1 ) ;  then 
	VERY_NICE="$NICE -$NICE_VALUE"
      fi
     fi 
fi
if test "x$1" = "x"; then
  VERY_NICE=`echo $VERY_NICE | sed "s/$NICE_VALUE/NICE_VALUE/"`
fi
AC_MSG_RESULT($VERY_NICE)
AC_SUBST(VERY_NICE)
])
